--rev 18 -  rewrite..

require "classes/Card"
require "classes/Cardspot"
require "classes/Score"

playerScore = 5
enemyScore = 5
cardSpotIsFull = {0,0,0,0,0,0,0,0,0}
cardSelected = 0;
spotSelected = 0;
gameStarted = 0;
turn = 0;
enemyHandOrderNum = love.math.random(1,5);
if(enemyHandOrderNum==1) then
enemyHand = {6,7,8,9,10}
elseif (enemyHandOrderNum==2) then
enemyHand = {10,7,9,8,6}
elseif (enemyHandOrderNum==3) then
enemyHand = {7,9,10,6,8}
elseif (enemyHandOrderNum==4) then
enemyHand = {8,6,7,10,9}
elseif (enemyHandOrderNum==5) then
enemyHand = {9,8,6,10,7}
end
enemyHandPos = 6;

function updateScore(scoreObject, scoreValue, cardspotPlaced)
    if(scoreValue<10) then
        scoreObject.image = love.graphics.newImage(love.image.newImageData("images/scores/"..scoreValue..".png"))
        cardspotPlaced.placed = 1
        if(turn==1) then
            turn = 2
        elseif(turn==2) then
            turn = 1
        end
    end
end

function updateCardImage(cardID)

--love.graphics.newImage(love.image.newImageData("images/cards/"..p1.filename..".jpg"))
end

function compareCardValues()

    print("COMPARE: cardSelected "..cardSelected.." and spotSelected "..spotSelected)
  
    for i=1,9 do
        --print(spots[i].cardID)
            if(spots[i].cardID < 6 and spots[i+1].cardID >=6) then
                if(playercardsOnTable[spots[i].cardID].eAtk > enemycardsOnTable[spots[i+1].cardID].wAtk) then
                    print("LOL IF THIS WORKS...")
                end
            end
    end

--updateCardImage()
end

function enemyTurn()
    cardSelected = enemyHandPos;
    setCardSelected();
    spotSelectedNum = 0

    for i=1,9 do
        spotSelectedNum = love.math.random(1,9);
        if(cardSpotIsFull[spotSelectedNum] == 0) then
            spotSelected = spotSelectedNum
            break
        end
    end
    cardSpotIsFull[spotSelected] = 1
    --print("card now in place at spot "..cardSpotIsFull[spotSelected])
    print("CARD SELECTED: "..cardSelected.." SPOT SELECTED: "..spotSelected)
    setObjectData()
    enemyHandPos = enemyHandPos+1
    cardSelected = 0
end

function setCardSelected()
    if(cardSelected<6) then
        for i=1,5 do
            if(playercardsOnTable[i].used == 0) then
                playercardsOnTable[i].x = 40
            end
        end
        playercardsOnTable[cardSelected].x = 60;
    end
    
    if(cardSelected>5) then
        for i=6,10 do
            if(enemycardsOnTable[i].used == 0) then
                enemycardsOnTable[i].x = 660
            end
        end
        enemycardsOnTable[cardSelected].x = 640;
    end
end

function setCardValues()    
    if(cardSelected<6) then
        spots[spotSelected].cardID = playercardsOnTable[cardSelected].cardID;
        playercardsOnTable[cardSelected].used = 1  
    end
    
    if(cardSelected>5) then
        spots[spotSelected].cardID = enemycardsOnTable[cardSelected].cardID;
        enemycardsOnTable[cardSelected].used = 1
    end
    --print("cardID "..spots[spotSelected].cardID.." placed on cardspot "..spotSelected)
end

function setObjectData()
cardSpotIsFull[spotSelected] = 1
--print("card now in place at spot "..spotSelected.." and cardfull is "..cardSpotIsFull[spotSelected])
if(cardSelected<6) then
    playercardsOnTable[cardSelected].x = spots[spotSelected].x;
    playercardsOnTable[cardSelected].y = spots[spotSelected].y;
end

if(cardSelected>5) then
    enemycardsOnTable[cardSelected].x = spots[spotSelected].x;
    enemycardsOnTable[cardSelected].y = spots[spotSelected].y;
end
setCardValues();
compareCardValues();
end

function love.load()
    love.window.setTitle("TripleTriad Ultimate")
    bg = love.graphics.newImage( '/images/playmat.png' )

    spots = {}
    for i=0,8 do
      spots[i+1] = Cardspot:new("fancy", 0, 0, 0, 0)
      spots[i+1].x = 220 + (i%3)*130
      spots[i+1].y = 120 + math.floor(i/3)*150
    end

    playerHand = {"bitebug","blobra","bloodsoul","caterchipillar","cockatrice"}
    enemyHand = {}
    for i=1,5 do
        enemyHand[i] = 'r'..Cards[love.math.random(1, 11)]
    end

    playercardsOnTable = {}
    for i=1,5 do
      playercardsOnTable[i] = getCard(playerHand[i])
      playercardsOnTable[i].cardID = i;
      playercardsOnTable[i].x = 40
      playercardsOnTable[i].y = 60+i*60
      playercardsOnTable[i].owner = "blue"
    end
    enemycardsOnTable = {}
    for i=6,10 do
      enemycardsOnTable[i] = getCard(enemyHand[i-5])
      enemycardsOnTable[i].cardID = i;
      enemycardsOnTable[i].x = 660
      enemycardsOnTable[i].y = 60+(i-5)*60
      enemycardsOnTable[i].owner = "red"
    end

    s = {
      Score:new(playerScore), 
      Score:new(enemyScore)
    }
    s[1].x, s[1].y = 80, 50
    s[2].x, s[2].y = 700, 50

    if gameStarted == 0 then
        turn = love.math.random(1,2)
        print(turn)
    end

    if turn == 2 then
        enemyTurn()
    end
end

Cards = {"bitebug", "blobra", "bloodsoul", "caterchipillar", "cockatrice", "fastitocalonf", "funguar", "gayla", "geezard", "gesper", "redbat"}
-- to get PlayerCards do: Cards[i]
-- to get EnemyCards do: 'r' .. Cards[i]

local cardTemplate = {
  bitebug        = {5,1,3,3},
  blobra         = {5,2,3,1},
  bloodsoul      = {1,2,1,6},
  caterchipillar = {3,4,2,4},
  cockatrice     = {6,2,1,2},
  fastitocalonf  = {1,3,5,2},
  funguar        = {3,5,1,1},
  gayla          = {4,2,1,4},
  geezard        = {5,1,4,1},
  gesper         = {1,1,5,4},
  redbat         = {2,6,1,1},
}
function getCard(name)
  local filename = name
  return Card:new(filename, cardTemplate[1], cardTemplate[2], cardTemplate[3], cardTemplate[4])
end

function love.draw()
    love.graphics.draw(bg, 0, 0)

    for i, o in ipairs(spots) do
      love.graphics.draw(o.image, o.x, o.y)
    end
    for i, o in ipairs(playercardsOnTable) do
      love.graphics.draw(o.image, o.x, o.y)
    end
    for i=6,10 do
        love.graphics.draw(enemycardsOnTable[i].image, enemycardsOnTable[i].x, enemycardsOnTable[i].y)
    end
    love.graphics.draw(s[1].image, s[1].x, s[1].y)
    love.graphics.draw(s[2].image, s[2].x, s[2].y)
end
   	
function love.mousepressed(x, y, button)
if button == "l" then
    --PlayerCards
    if (x > 40 and x < 140) and (y>100 and y<160) then
        if(playercardsOnTable[1].used == 0) then
            cardSelected = 1;
            setCardSelected();
            --print("playercard clicked at "..x,y.." card selected "..cardSelected)
        end
    end
    if (x > 40 and x < 140) and (y>160 and y<220) then
        if(playercardsOnTable[2].used == 0) then
            cardSelected = 2;
            setCardSelected();
        end
    end
    if (x > 40 and x < 140) and (y>220 and y<280) then
        if(playercardsOnTable[3].used == 0) then
            cardSelected = 3;
            setCardSelected();
        end
    end
    if (x > 40 and x < 140) and (y>280 and y<340) then
        if(playercardsOnTable[4].used == 0) then
            cardSelected = 4;
            setCardSelected();
        end
    end
    if (x > 40 and x < 140) and (y>340 and y<460) then
        if(playercardsOnTable[5].used == 0) then
            cardSelected = 5;
            setCardSelected();
        end
    end
    --Cardspots
    if (x > 220 and x < 320) and (y>120 and y<247) then
        --print("cardspot 1 clicked at "..x,y)
        spotSelected = 1;
        setObjectData()
        enemyTurn()
        
    end
    if (x > 350 and x < 450) and (y>120 and y<247) then
        --print("cardspot 2 clicked at "..x,y)
        spotSelected = 2;
        setObjectData()
        enemyTurn()   
    end
    if (x > 480 and x < 580) and (y>120 and y<247) then
        --print("cardspot 3 clicked at "..x,y)
        spotSelected = 3;
        setObjectData()
        enemyTurn()        
    end
    if (x > 220 and x < 320) and (y>270 and y<397) then
        --print("cardspot 4 clicked at "..x,y)
        spotSelected = 4;
        setObjectData()
        enemyTurn()       
    end
    if (x > 350 and x < 450) and (y>270 and y<397) then
        --print("cardspot 5 clicked at "..x,y)
        spotSelected = 5;
        setObjectData()
        enemyTurn()        
    end
    if (x > 480 and x < 580) and (y>270 and y<397) then
        --print("cardspot 6 clicked at "..x,y)
        spotSelected = 6;
        setObjectData()
        enemyTurn()       
    end
    if (x > 220 and x < 320) and (y>420 and y<547) then
        --print("cardspot 7 clicked at "..x,y)
        spotSelected = 7;
        setObjectData()
        enemyTurn()        
    end
    if (x > 350 and x < 450) and (y>420 and y<547) then
        --print("cardspot 8 clicked at "..x,y)
        spotSelected = 8;
        setObjectData()
        enemyTurn()       
    end
    if (x > 480 and x < 580) and (y>420 and y<547) then
        --print("cardspot 9 clicked at "..x,y)
        spotSelected = 9;
        setObjectData()
        enemyTurn()      
    end
end

end
